<template>
  <div id="login">
    <div class="container">
      <div id="login-row" class="row justify-content-center align-items-center">
        <div id="login-column" class="col-md-4">
          <div id="login-box" class="col-md-12">
            <form id="login-form" class="form" @submit.prevent="login">

              <div v-if="errors.non_field_errors" class="field-error">
                {{errors.non_field_errors[0]}}
              </div>

              <div class="form-group">
                <label for="email" class="text-info">Email addres:</label><br>
                <input v-model="email" type="text" name="email" id="email" class="form-control" placeholder="Email adres">
                <div v-if="errors.username" class="field-error">{{errors.username[0]}}</div>
              </div>
              <div class="form-group">
                <label for="password" class="text-info">Wachtwoord:</label><br>
                <input v-model="password" type="password" name="password" id="password" class="form-control" placeholder="Wachtwoord">
                <div v-if="errors.password" class="field-error">{{errors.password[0]}}</div>
              </div>
              <div class="form-group">
                <button type="submit" class="btn btn-success btn-md">
                  Login
                  <div v-if="isAuthenticationPending" class="spinner-border spinner-border-sm" role="status">
                    <span class="sr-only">Laden..</span>
                  </div>
                </button>
              </div>

              <hr>

              <div class="text-info m-2">
                <p>Heeft u nog geen account? <br/> Registreer u gratis!</p>
              </div>
              <div @click="$router.push('register');" class="btn btn-info btn-md">
                Nieuw account maken
              </div>
              <hr>

            </form>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import {mapGetters} from "vuex";

import {AUTH_REQUEST} from "@/store/actions/auth";

export default {
  name: 'Login',
  data() {
    return {
      email: this.$store.getters.registrationContext.email,
      password: '',
      errors: {}
    }
  },
  methods: {
    login: function() {
      const {email, password} = this
      this.$store.dispatch(AUTH_REQUEST, {
        email,
        password
      }).then(() => {
        this.$router.push('/');
      }).catch(error => {
        this.$set(this, 'errors', error.response.data)
      })
    }
  },
  computed: {
    ...mapGetters(['isAuthenticationPending'])
  }
}
</script>

<style scoped>
</style>
